> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-transactions/builders/makecontractcall.md).

# makeContractCall

Constructs and signs a smart contract function call transaction. Calls a public function on a deployed Clarity smart contract.

***

### Usage

```ts
import {
  makeContractCall,
  Cl,
  PostConditionMode,
} from '@stacks/transactions';

const transaction = await makeContractCall({
  contractAddress: 'ST1PQHQKV0RJXZFY1DGX8MNSNYVE3VGZJSRTPGZGM',
  contractName: 'my-contract',
  functionName: 'transfer',
  functionArgs: [
    Cl.uint(1000),
    Cl.standardPrincipal('ST1SJ3DTE5DN7X54YDH5D64R3BCB6A2AG2ZQ8YPD5'),
  ],
  senderKey: 'b244296d5907de9864c0b0d51f98a13c52890be0404e83f273144004b81874603',
  network: 'testnet',
  postConditionMode: PostConditionMode.Deny,
  fee: 10000n,
  nonce: 0n,
});

const serializedTx = transaction.serialize();
```

#### Notes

* The `functionArgs` must match the types expected by the Clarity function.
* Use the `Cl` namespace helpers (e.g. `Cl.uint`, `Cl.standardPrincipal`) to construct Clarity values.
* If the contract's ABI is needed for validation, it is fetched automatically unless `validateWithAbi` is set to `false`.
* If `fee` is omitted, the fee is estimated automatically.
* If `nonce` is omitted, the nonce is fetched automatically.

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/transactions/src/builders.ts#L565)

***

### Signature

```ts
function makeContractCall(
  txOptions: SignedContractCallOptions | SignedMultiSigContractCallOptions
): Promise<StacksTransactionWire>
```

***

### Returns

`Promise<StacksTransactionWire>`

A promise that resolves to a signed `StacksTransactionWire` object, ready to be broadcast.

***

### Parameters

#### txOptions (required)

* **Type**: `SignedContractCallOptions | SignedMultiSigContractCallOptions`

```ts
interface SignedContractCallOptions extends ContractCallOptions {
  senderKey: PrivateKey;
}

type SignedMultiSigContractCallOptions = ContractCallOptions & SignedMultiSigOptions;

type ContractCallOptions = {
  /** The address of the contract */
  contractAddress: string;
  /** The name of the contract */
  contractName: string;
  /** The name of the function to call */
  functionName: string;
  /** The arguments to pass to the function */
  functionArgs: ClarityValue[];
  /** Whether to validate the function call against the ABI */
  validateWithAbi?: boolean | ClarityAbi;
  /** Post conditions for the transaction */
  postConditions?: PostCondition[];
  /** Post condition mode (Allow or Deny) */
  postConditionMode?: PostConditionMode;
  /** Whether the transaction is sponsored */
  sponsored?: boolean;
  /** Transaction fee in microSTX */
  fee?: IntegerType;
  /** Transaction nonce */
  nonce?: IntegerType;
} & NetworkClientParam;
```

For single-sig, provide `senderKey`. For multi-sig, provide `publicKeys`, `numSignatures`, and `signerKeys`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-transactions/builders/makecontractcall.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
